#	Copyright Hunter Moseley, 2009. All rights reserved.
# shifts from BMRB around early 2001.

package BMRB::ExpectedValues;
require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw();
@EXPORT_OK = qw(amino_acid_expected_shifts amino_acid_type_lists);
%EXPORT_TAGS = ( ALL => [@EXPORT_OK] );

use strict;

sub amino_acid_expected_shifts
  {
  my $deuteration = shift @_;

  my $count = {};
  my $mean = {};
  my $variance = {};
  my $min = {};
  my $max = {};

  $$min{A}{H} = 3.97;
  $$max{A}{H} = 11.58;
  $$mean{A}{H} = 8.20;
  $$count{A}{H} = 1;
  $$variance{A}{H} = 0.60 * 0.60;
  
  $$min{A}{HA} = 1.92;
  $$max{A}{HA} = 6.16;
  $$mean{A}{HA} = 4.26;
  $$count{A}{HA} = 1;
  $$variance{A}{HA} = 0.42 * 0.42;
  
  $$min{A}{HB} = -0.62;
  $$max{A}{HB} = 2.63;
  $$mean{A}{HB} = 1.38;
  $$count{A}{HB} = 1;
  $$variance{A}{HB} = 0.25 * 0.25;
  
  $$min{A}{C} = 168.80;
  $$max{A}{C} = 183.70;
  $$mean{A}{C} = 177.80;
  $$count{A}{C} = 1;
  $$variance{A}{C} = 2.18 * 2.18;
  
  $$min{A}{CA} = 43.00;
  $$max{A}{CA} = 63.50;
  $$mean{A}{CA} = 53.16;
  $$count{A}{CA} = 1;
  $$variance{A}{CA} = 2.06 * 2.06;
  
  $$min{A}{CB} = 0.00;
  $$max{A}{CB} = 26.30;
  $$mean{A}{CB} = 18.90;
  $$count{A}{CB} = 1;
  $$variance{A}{CB} = 1.85 * 1.85;
  
  $$min{A}{N} = 99.44;
  $$max{A}{N} = 137.20;
  $$mean{A}{N} = 123.23;
  $$count{A}{N} = 1;
  $$variance{A}{N} = 3.70 * 3.70;
  
  
  $$min{R}{H} = 5.02;
  $$max{R}{H} = 11.38;
  $$mean{R}{H} = 8.24;
  $$count{R}{H} = 1;
  $$variance{R}{H} = 0.60 * 0.60;
  
  $$min{R}{HA} = 2.12;
  $$max{R}{HA} = 5.94;
  $$mean{R}{HA} = 4.27;
  $$count{R}{HA} = 1;
  $$variance{R}{HA} = 0.44 * 0.44;
  
  $$min{R}{HB2} = -0.38;
  $$max{R}{HB2} = 3.29;
  $$mean{R}{HB2} = 1.79;
  $$count{R}{HB2} = 1;
  $$variance{R}{HB2} = 0.28 * 0.28;
  
  $$min{R}{HB3} = 0.00;
  $$max{R}{HB3} = 3.29;
  $$mean{R}{HB3} = 1.78;
  $$count{R}{HB3} = 1;
  $$variance{R}{HB3} = 0.28 * 0.28;
  
  $$min{R}{HG2} = -0.64;
  $$max{R}{HG2} = 3.12;
  $$mean{R}{HG2} = 1.58;
  $$count{R}{HG2} = 1;
  $$variance{R}{HG2} = 0.27 * 0.27;
  
  $$min{R}{HG3} = -0.23;
  $$max{R}{HG3} = 3.12;
  $$mean{R}{HG3} = 1.58;
  $$count{R}{HG3} = 1;
  $$variance{R}{HG3} = 0.27 * 0.27;
  
  $$min{R}{HD2} = 1.43;
  $$max{R}{HD2} = 4.28;
  $$mean{R}{HD2} = 3.13;
  $$count{R}{HD2} = 1;
  $$variance{R}{HD2} = 0.23 * 0.23;
  
  $$min{R}{HD3} = 1.22;
  $$max{R}{HD3} = 4.28;
  $$mean{R}{HD3} = 3.13;
  $$count{R}{HD3} = 1;
  $$variance{R}{HD3} = 0.22 * 0.22;
  
  $$min{R}{HE} = 3.25;
  $$max{R}{HE} = 11.82;
  $$mean{R}{HE} = 7.32;
  $$count{R}{HE} = 1;
  $$variance{R}{HE} = 0.52 * 0.52;
  
  $$min{R}{HH11} = 5.82;
  $$max{R}{HH11} = 8.76;
  $$mean{R}{HH11} = 6.74;
  $$count{R}{HH11} = 1;
  $$variance{R}{HH11} = 0.31 * 0.31;
  
  $$min{R}{HH12} = 5.82;
  $$max{R}{HH12} = 8.76;
  $$mean{R}{HH12} = 6.75;
  $$count{R}{HH12} = 1;
  $$variance{R}{HH12} = 0.32 * 0.32;
  
  $$min{R}{HH21} = 4.59;
  $$max{R}{HH21} = 7.62;
  $$mean{R}{HH21} = 6.72;
  $$count{R}{HH21} = 1;
  $$variance{R}{HH21} = 0.32 * 0.32;
  
  $$min{R}{HH22} = 4.59;
  $$max{R}{HH22} = 7.62;
  $$mean{R}{HH22} = 6.72;
  $$count{R}{HH22} = 1;
  $$variance{R}{HH22} = 0.33 * 0.33;
  
  $$min{R}{C} = 168.67;
  $$max{R}{C} = 181.50;
  $$mean{R}{C} = 176.49;
  $$count{R}{C} = 1;
  $$variance{R}{C} = 2.16 * 2.16;
  
  $$min{R}{CA} = 46.10;
  $$max{R}{CA} = 65.13;
  $$mean{R}{CA} = 56.95;
  $$count{R}{CA} = 1;
  $$variance{R}{CA} = 2.41 * 2.41;
  
  $$min{R}{CB} = 24.50;
  $$max{R}{CB} = 38.27;
  $$mean{R}{CB} = 30.66;
  $$count{R}{CB} = 1;
  $$variance{R}{CB} = 1.77 * 1.77;
  
  $$min{R}{CG} = 18.22;
  $$max{R}{CG} = 49.39;
  $$mean{R}{CG} = 27.31;
  $$count{R}{CG} = 1;
  $$variance{R}{CG} = 1.65 * 1.65;
  
  $$min{R}{CD} = 29.71;
  $$max{R}{CD} = 45.60;
  $$mean{R}{CD} = 43.10;
  $$count{R}{CD} = 1;
  $$variance{R}{CD} = 1.10 * 1.10;
  
  $$min{R}{CZ} = 157.52;
  $$max{R}{CZ} = 160.60;
  $$mean{R}{CZ} = 159.01;
  $$count{R}{CZ} = 1;
  $$variance{R}{CZ} = 0.87 * 0.87;
  
  $$min{R}{N} = 103.60;
  $$max{R}{N} = 137.60;
  $$mean{R}{N} = 120.61;
  $$count{R}{N} = 1;
  $$variance{R}{N} = 3.90 * 3.90;
  
  $$min{R}{NE} = 7.28;
  $$max{R}{NE} = 128.90;
  $$mean{R}{NE} = 89.80;
  $$count{R}{NE} = 1;
  $$variance{R}{NE} = 12.83 * 12.83;
  
  $$min{R}{NH1} = 70.10;
  $$max{R}{NH1} = 112.50;
  $$mean{R}{NH1} = 74.78;
  $$count{R}{NH1} = 1;
  $$variance{R}{NH1} = 11.38 * 11.38;
  
  $$min{R}{NH2} = 70.10;
  $$max{R}{NH2} = 111.90;
  $$mean{R}{NH2} = 75.84;
  $$count{R}{NH2} = 1;
  $$variance{R}{NH2} = 11.44 * 11.44;
  
  
  $$min{D}{H} = 6.12;
  $$max{D}{H} = 11.54;
  $$mean{D}{H} = 8.33;
  $$count{D}{H} = 1;
  $$variance{D}{H} = 0.57 * 0.57;
  
  $$min{D}{HA} = 2.59;
  $$max{D}{HA} = 6.33;
  $$mean{D}{HA} = 4.61;
  $$count{D}{HA} = 1;
  $$variance{D}{HA} = 0.31 * 0.31;
  
  $$min{D}{HB2} = 1.25;
  $$max{D}{HB2} = 6.60;
  $$mean{D}{HB2} = 2.74;
  $$count{D}{HB2} = 1;
  $$variance{D}{HB2} = 0.29 * 0.29;
  
  $$min{D}{HB3} = 0.65;
  $$max{D}{HB3} = 4.58;
  $$mean{D}{HB3} = 2.70;
  $$count{D}{HB3} = 1;
  $$variance{D}{HB3} = 0.29 * 0.29;
  
  $$min{D}{C} = 166.80;
  $$max{D}{C} = 181.65;
  $$mean{D}{C} = 176.41;
  $$count{D}{C} = 1;
  $$variance{D}{C} = 1.77 * 1.77;
  
  $$min{D}{CA} = 39.80;
  $$max{D}{CA} = 60.37;
  $$mean{D}{CA} = 54.52;
  $$count{D}{CA} = 1;
  $$variance{D}{CA} = 2.10 * 2.10;
  
  $$min{D}{CB} = 29.51;
  $$max{D}{CB} = 48.30;
  $$mean{D}{CB} = 40.70;
  $$count{D}{CB} = 1;
  $$variance{D}{CB} = 1.67 * 1.67;
  
  $$min{D}{CG} = 173.49;
  $$max{D}{CG} = 181.31;
  $$mean{D}{CG} = 178.41;
  $$count{D}{CG} = 1;
  $$variance{D}{CG} = 1.84 * 1.84;
  
  $$min{D}{N} = 105.50;
  $$max{D}{N} = 136.80;
  $$mean{D}{N} = 120.73;
  $$count{D}{N} = 1;
  $$variance{D}{N} = 4.20 * 4.20;
  
  
  $$min{N}{H} = 3.61;
  $$max{N}{H} = 12.40;
  $$mean{N}{H} = 8.37;
  $$count{N}{H} = 1;
  $$variance{N}{H} = 0.65 * 0.65;
  
  $$min{N}{HA} = 2.92;
  $$max{N}{HA} = 6.32;
  $$mean{N}{HA} = 4.70;
  $$count{N}{HA} = 1;
  $$variance{N}{HA} = 0.39 * 0.39;
  
  $$min{N}{HB2} = 0.10;
  $$max{N}{HB2} = 4.47;
  $$mean{N}{HB2} = 2.80;
  $$count{N}{HB2} = 1;
  $$variance{N}{HB2} = 0.34 * 0.34;
  
  $$min{N}{HB3} = 0.26;
  $$max{N}{HB3} = 4.47;
  $$mean{N}{HB3} = 2.78;
  $$count{N}{HB3} = 1;
  $$variance{N}{HB3} = 0.34 * 0.34;
  
  $$min{N}{HD21} = 3.33;
  $$max{N}{HD21} = 9.30;
  $$mean{N}{HD21} = 7.27;
  $$count{N}{HD21} = 1;
  $$variance{N}{HD21} = 0.52 * 0.52;
  
  $$min{N}{HD22} = 3.14;
  $$max{N}{HD22} = 10.33;
  $$mean{N}{HD22} = 7.20;
  $$count{N}{HD22} = 1;
  $$variance{N}{HD22} = 0.52 * 0.52;
  
  $$min{N}{C} = 168.60;
  $$max{N}{C} = 180.20;
  $$mean{N}{C} = 175.16;
  $$count{N}{C} = 1;
  $$variance{N}{C} = 1.76 * 1.76;
  
  $$min{N}{CA} = 43.30;
  $$max{N}{CA} = 62.30;
  $$mean{N}{CA} = 53.43;
  $$count{N}{CA} = 1;
  $$variance{N}{CA} = 1.94 * 1.94;
  
  $$min{N}{CB} = 29.20;
  $$max{N}{CB} = 45.81;
  $$mean{N}{CB} = 38.66;
  $$count{N}{CB} = 1;
  $$variance{N}{CB} = 1.78 * 1.78;
  
  $$min{N}{CG} = 173.50;
  $$max{N}{CG} = 179.43;
  $$mean{N}{CG} = 176.61;
  $$count{N}{CG} = 1;
  $$variance{N}{CG} = 1.33 * 1.33;
  
  $$min{N}{N} = 105.00;
  $$max{N}{N} = 132.70;
  $$mean{N}{N} = 119.13;
  $$count{N}{N} = 1;
  $$variance{N}{N} = 4.42 * 4.42;
  
  $$min{N}{ND2} = 104.00;
  $$max{N}{ND2} = 124.77;
  $$mean{N}{ND2} = 112.83;
  $$count{N}{ND2} = 1;
  $$variance{N}{ND2} = 2.60 * 2.60;
  
  
  $$min{C}{H} = 5.05;
  $$max{C}{H} = 10.74;
  $$mean{C}{H} = 8.42;
  $$count{C}{H} = 1;
  $$variance{C}{H} = 0.66 * 0.66;
  
  $$min{C}{HA} = 1.70;
  $$max{C}{HA} = 6.19;
  $$mean{C}{HA} = 4.73;
  $$count{C}{HA} = 1;
  $$variance{C}{HA} = 0.57 * 0.57;
  
  $$min{C}{HB2} = 0.29;
  $$max{C}{HB2} = 4.65;
  $$mean{C}{HB2} = 2.95;
  $$count{C}{HB2} = 1;
  $$variance{C}{HB2} = 0.43 * 0.43;
  
  $$min{C}{HB3} = -0.28;
  $$max{C}{HB3} = 4.65;
  $$mean{C}{HB3} = 2.98;
  $$count{C}{HB3} = 1;
  $$variance{C}{HB3} = 0.45 * 0.45;
  
  $$min{C}{HG} = 1.38;
  $$max{C}{HG} = 2.22;
  $$mean{C}{HG} = 1.66;
  $$count{C}{HG} = 1;
  $$variance{C}{HG} = 0.48 * 0.48;
  
  $$min{C}{C} = 168.50;
  $$max{C}{C} = 180.71;
  $$mean{C}{C} = 174.78;
  $$count{C}{C} = 1;
  $$variance{C}{C} = 1.99 * 1.99;
  
  $$min{C}{CA} = 49.74;
  $$max{C}{CA} = 66.25;
  $$mean{C}{CA} = 57.43;
  $$count{C}{CA} = 1;
  $$variance{C}{CA} = 3.41 * 3.41;
  
  $$min{C}{CB} = 22.30;
  $$max{C}{CB} = 57.00;
  $$mean{C}{CB} = 34.15;
  $$count{C}{CB} = 1;
  $$variance{C}{CB} = 6.77 * 6.77;
  
  $$min{C}{N} = 106.60;
  $$max{C}{N} = 135.89;
  $$mean{C}{N} = 119.95;
  $$count{C}{N} = 1;
  $$variance{C}{N} = 4.79 * 4.79;
  
  
  $$min{E}{H} = 4.98;
  $$max{E}{H} = 11.72;
  $$mean{E}{H} = 8.34;
  $$count{E}{H} = 1;
  $$variance{E}{H} = 0.61 * 0.61;
  
  $$min{E}{HA} = 1.77;
  $$max{E}{HA} = 6.29;
  $$mean{E}{HA} = 4.26;
  $$count{E}{HA} = 1;
  $$variance{E}{HA} = 0.43 * 0.43;
  
  $$min{E}{HB2} = 0.12;
  $$max{E}{HB2} = 3.21;
  $$mean{E}{HB2} = 2.04;
  $$count{E}{HB2} = 1;
  $$variance{E}{HB2} = 0.22 * 0.22;
  
  $$min{E}{HB3} = 0.06;
  $$max{E}{HB3} = 3.13;
  $$mean{E}{HB3} = 2.04;
  $$count{E}{HB3} = 1;
  $$variance{E}{HB3} = 0.23 * 0.23;
  
  $$min{E}{HG2} = 0.85;
  $$max{E}{HG2} = 3.68;
  $$mean{E}{HG2} = 2.31;
  $$count{E}{HG2} = 1;
  $$variance{E}{HG2} = 0.21 * 0.21;
  
  $$min{E}{HG3} = 1.06;
  $$max{E}{HG3} = 3.68;
  $$mean{E}{HG3} = 2.31;
  $$count{E}{HG3} = 1;
  $$variance{E}{HG3} = 0.21 * 0.21;
  
  $$min{E}{C} = 167.90;
  $$max{E}{C} = 181.70;
  $$mean{E}{C} = 176.93;
  $$count{E}{C} = 1;
  $$variance{E}{C} = 2.11 * 2.11;
  
  $$min{E}{CA} = 46.80;
  $$max{E}{CA} = 66.60;
  $$mean{E}{CA} = 57.42;
  $$count{E}{CA} = 1;
  $$variance{E}{CA} = 2.19 * 2.19;
  
  $$min{E}{CB} = 21.70;
  $$max{E}{CB} = 44.18;
  $$mean{E}{CB} = 30.07;
  $$count{E}{CB} = 1;
  $$variance{E}{CB} = 1.84 * 1.84;
  
  $$min{E}{CG} = 25.10;
  $$max{E}{CG} = 51.92;
  $$mean{E}{CG} = 36.01;
  $$count{E}{CG} = 1;
  $$variance{E}{CG} = 1.51 * 1.51;
  
  $$min{E}{CD} = 177.76;
  $$max{E}{CD} = 184.74;
  $$mean{E}{CD} = 181.94;
  $$count{E}{CD} = 1;
  $$variance{E}{CD} = 1.85 * 1.85;
  
  $$min{E}{N} = 109.80;
  $$max{E}{N} = 137.30;
  $$mean{E}{N} = 120.68;
  $$count{E}{N} = 1;
  $$variance{E}{N} = 3.68 * 3.68;
  
  
  $$min{Q}{H} = 5.93;
  $$max{Q}{H} = 11.94;
  $$mean{Q}{H} = 8.22;
  $$count{Q}{H} = 1;
  $$variance{Q}{H} = 0.62 * 0.62;
  
  $$min{Q}{HA} = 2.39;
  $$max{Q}{HA} = 6.18;
  $$mean{Q}{HA} = 4.28;
  $$count{Q}{HA} = 1;
  $$variance{Q}{HA} = 0.44 * 0.44;
  
  $$min{Q}{HB2} = -0.22;
  $$max{Q}{HB2} = 4.00;
  $$mean{Q}{HB2} = 2.05;
  $$count{Q}{HB2} = 1;
  $$variance{Q}{HB2} = 0.28 * 0.28;
  
  $$min{Q}{HB3} = -0.22;
  $$max{Q}{HB3} = 4.04;
  $$mean{Q}{HB3} = 2.04;
  $$count{Q}{HB3} = 1;
  $$variance{Q}{HB3} = 0.29 * 0.29;
  
  $$min{Q}{HG2} = 0.06;
  $$max{Q}{HG2} = 3.66;
  $$mean{Q}{HG2} = 2.32;
  $$count{Q}{HG2} = 1;
  $$variance{Q}{HG2} = 0.29 * 0.29;
  
  $$min{Q}{HG3} = 0.26;
  $$max{Q}{HG3} = 3.66;
  $$mean{Q}{HG3} = 2.32;
  $$count{Q}{HG3} = 1;
  $$variance{Q}{HG3} = 0.29 * 0.29;
  
  $$min{Q}{HE21} = 5.21;
  $$max{Q}{HE21} = 9.14;
  $$mean{Q}{HE21} = 7.17;
  $$count{Q}{HE21} = 1;
  $$variance{Q}{HE21} = 0.46 * 0.46;
  
  $$min{Q}{HE22} = 4.30;
  $$max{Q}{HE22} = 9.02;
  $$mean{Q}{HE22} = 7.07;
  $$count{Q}{HE22} = 1;
  $$variance{Q}{HE22} = 0.49 * 0.49;
  
  $$min{Q}{C} = 170.37;
  $$max{Q}{C} = 182.22;
  $$mean{Q}{C} = 176.39;
  $$count{Q}{C} = 1;
  $$variance{Q}{C} = 1.96 * 1.96;
  
  $$min{Q}{CA} = 47.70;
  $$max{Q}{CA} = 61.42;
  $$mean{Q}{CA} = 56.62;
  $$count{Q}{CA} = 1;
  $$variance{Q}{CA} = 2.19 * 2.19;
  
  $$min{Q}{CB} = 21.70;
  $$max{Q}{CB} = 41.54;
  $$mean{Q}{CB} = 29.10;
  $$count{Q}{CB} = 1;
  $$variance{Q}{CB} = 1.97 * 1.97;
  
  $$min{Q}{CG} = 26.10;
  $$max{Q}{CG} = 39.44;
  $$mean{Q}{CG} = 33.72;
  $$count{Q}{CG} = 1;
  $$variance{Q}{CG} = 1.10 * 1.10;
  
  $$min{Q}{CD} = 172.80;
  $$max{Q}{CD} = 181.25;
  $$mean{Q}{CD} = 179.68;
  $$count{Q}{CD} = 1;
  $$variance{Q}{CD} = 1.17 * 1.17;
  
  $$min{Q}{N} = 105.10;
  $$max{Q}{N} = 136.00;
  $$mean{Q}{N} = 119.92;
  $$count{Q}{N} = 1;
  $$variance{Q}{N} = 4.01 * 4.01;
  
  $$min{Q}{NE2} = 92.49;
  $$max{Q}{NE2} = 122.30;
  $$mean{Q}{NE2} = 111.81;
  $$count{Q}{NE2} = 1;
  $$variance{Q}{NE2} = 2.20 * 2.20;
  
  
  $$min{G}{H} = 3.15;
  $$max{G}{H} = 12.22;
  $$mean{G}{H} = 8.34;
  $$count{G}{H} = 1;
  $$variance{G}{H} = 0.74 * 0.74;
  
  $$min{G}{HA2} = 0.34;
  $$max{G}{HA2} = 6.17;
  $$mean{G}{HA2} = 3.95;
  $$count{G}{HA2} = 1;
  $$variance{G}{HA2} = 0.40 * 0.40;
  
  $$min{G}{HA3} = 1.27;
  $$max{G}{HA3} = 6.01;
  $$mean{G}{HA3} = 3.93;
  $$count{G}{HA3} = 1;
  $$variance{G}{HA3} = 0.40 * 0.40;
  
  $$min{G}{C} = 165.80;
  $$max{G}{C} = 182.40;
  $$mean{G}{C} = 174.04;
  $$count{G}{C} = 1;
  $$variance{G}{C} = 1.94 * 1.94;
  
  $$min{G}{CA} = 35.50;
  $$max{G}{CA} = 56.69;
  $$mean{G}{CA} = 45.33;
  $$count{G}{CA} = 1;
  $$variance{G}{CA} = 1.42 * 1.42;
  
  $$min{G}{N} = 88.30;
  $$max{G}{N} = 135.66;
  $$mean{G}{N} = 109.91;
  $$count{G}{N} = 1;
  $$variance{G}{N} = 4.29 * 4.29;
  
  
  $$min{H}{H} = 4.60;
  $$max{H}{H} = 10.80;
  $$mean{H}{H} = 8.25;
  $$count{H}{H} = 1;
  $$variance{H}{H} = 0.74 * 0.74;
  
  $$min{H}{HA} = 1.95;
  $$max{H}{HA} = 8.90;
  $$mean{H}{HA} = 4.62;
  $$count{H}{HA} = 1;
  $$variance{H}{HA} = 0.51 * 0.51;
  
  $$min{H}{HB2} = 0.37;
  $$max{H}{HB2} = 8.70;
  $$mean{H}{HB2} = 3.12;
  $$count{H}{HB2} = 1;
  $$variance{H}{HB2} = 0.43 * 0.43;
  
  $$min{H}{HB3} = 0.70;
  $$max{H}{HB3} = 8.70;
  $$mean{H}{HB3} = 3.11;
  $$count{H}{HB3} = 1;
  $$variance{H}{HB3} = 0.45 * 0.45;
  
  $$min{H}{HD1} = 6.29;
  $$max{H}{HD1} = 17.20;
  $$mean{H}{HD1} = 10.14;
  $$count{H}{HD1} = 1;
  $$variance{H}{HD1} = 3.50 * 3.50;
  
  $$min{H}{HD2} = 3.46;
  $$max{H}{HD2} = 8.82;
  $$mean{H}{HD2} = 7.08;
  $$count{H}{HD2} = 1;
  $$variance{H}{HD2} = 0.50 * 0.50;
  
  $$min{H}{HE1} = 3.21;
  $$max{H}{HE1} = 9.60;
  $$mean{H}{HE1} = 8.08;
  $$count{H}{HE1} = 1;
  $$variance{H}{HE1} = 0.57 * 0.57;
  
  $$min{H}{HE2} = 6.87;
  $$max{H}{HE2} = 16.53;
  $$mean{H}{HE2} = 10.43;
  $$count{H}{HE2} = 1;
  $$variance{H}{HE2} = 3.11 * 3.11;
  
  $$min{H}{C} = 167.60;
  $$max{H}{C} = 179.90;
  $$mean{H}{C} = 175.19;
  $$count{H}{C} = 1;
  $$variance{H}{C} = 2.14 * 2.14;
  
  $$min{H}{CA} = 45.80;
  $$max{H}{CA} = 65.40;
  $$mean{H}{CA} = 56.37;
  $$count{H}{CA} = 1;
  $$variance{H}{CA} = 2.40 * 2.40;
  
  $$min{H}{CB} = 23.70;
  $$max{H}{CB} = 40.86;
  $$mean{H}{CB} = 29.95;
  $$count{H}{CB} = 1;
  $$variance{H}{CB} = 2.15 * 2.15;
  
  $$min{H}{CG} = 122.67;
  $$max{H}{CG} = 136.80;
  $$mean{H}{CG} = 130.59;
  $$count{H}{CG} = 1;
  $$variance{H}{CG} = 3.41 * 3.41;
  
  $$min{H}{CD2} = 112.80;
  $$max{H}{CD2} = 138.85;
  $$mean{H}{CD2} = 119.84;
  $$count{H}{CD2} = 1;
  $$variance{H}{CD2} = 3.30 * 3.30;
  
  $$min{H}{CE1} = 115.52;
  $$max{H}{CE1} = 140.50;
  $$mean{H}{CE1} = 136.05;
  $$count{H}{CE1} = 1;
  $$variance{H}{CE1} = 3.58 * 3.58;
  
  $$min{H}{N} = 105.00;
  $$max{H}{N} = 133.70;
  $$mean{H}{N} = 119.44;
  $$count{H}{N} = 1;
  $$variance{H}{N} = 4.52 * 4.52;
  
  $$min{H}{ND1} = 106.60;
  $$max{H}{ND1} = 248.00;
  $$mean{H}{ND1} = 190.74;
  $$count{H}{ND1} = 1;
  $$variance{H}{ND1} = 22.84 * 22.84;
  
  $$min{H}{NE2} = 161.70;
  $$max{H}{NE2} = 231.50;
  $$mean{H}{NE2} = 179.81;
  $$count{H}{NE2} = 1;
  $$variance{H}{NE2} = 13.86 * 13.86;
  
  
  $$min{I}{H} = 3.75;
  $$max{I}{H} = 10.91;
  $$mean{I}{H} = 8.26;
  $$count{I}{H} = 1;
  $$variance{I}{H} = 0.71 * 0.71;
  
  $$min{I}{HA} = 1.03;
  $$max{I}{HA} = 6.30;
  $$mean{I}{HA} = 4.20;
  $$count{I}{HA} = 1;
  $$variance{I}{HA} = 0.56 * 0.56;
  
  $$min{I}{HB} = -0.57;
  $$max{I}{HB} = 2.79;
  $$mean{I}{HB} = 1.80;
  $$count{I}{HB} = 1;
  $$variance{I}{HB} = 0.31 * 0.31;
  
  $$min{I}{HG12} = -2.02;
  $$max{I}{HG12} = 2.57;
  $$mean{I}{HG12} = 1.30;
  $$count{I}{HG12} = 1;
  $$variance{I}{HG12} = 0.40 * 0.40;
  
  $$min{I}{HG13} = -2.04;
  $$max{I}{HG13} = 2.88;
  $$mean{I}{HG13} = 1.24;
  $$count{I}{HG13} = 1;
  $$variance{I}{HG13} = 0.40 * 0.40;
  
  $$min{I}{HG2} = -2.07;
  $$max{I}{HG2} = 1.77;
  $$mean{I}{HG2} = 0.80;
  $$count{I}{HG2} = 1;
  $$variance{I}{HG2} = 0.29 * 0.29;
  
  $$min{I}{HD1} = -1.06;
  $$max{I}{HD1} = 1.94;
  $$mean{I}{HD1} = 0.70;
  $$count{I}{HD1} = 1;
  $$variance{I}{HD1} = 0.30 * 0.30;
  
  $$min{I}{C} = 167.50;
  $$max{I}{C} = 182.70;
  $$mean{I}{C} = 175.82;
  $$count{I}{C} = 1;
  $$variance{I}{C} = 1.95 * 1.95;
  
  $$min{I}{CA} = 51.50;
  $$max{I}{CA} = 69.14;
  $$mean{I}{CA} = 61.59;
  $$count{I}{CA} = 1;
  $$variance{I}{CA} = 2.78 * 2.78;
  
  $$min{I}{CB} = 20.94;
  $$max{I}{CB} = 44.58;
  $$mean{I}{CB} = 38.58;
  $$count{I}{CB} = 1;
  $$variance{I}{CB} = 2.09 * 2.09;
  
  $$min{I}{CG1} = 9.80;
  $$max{I}{CG1} = 58.63;
  $$mean{I}{CG1} = 27.65;
  $$count{I}{CG1} = 1;
  $$variance{I}{CG1} = 2.32 * 2.32;
  
  $$min{I}{CG2} = 7.30;
  $$max{I}{CG2} = 24.40;
  $$mean{I}{CG2} = 17.36;
  $$count{I}{CG2} = 1;
  $$variance{I}{CG2} = 1.60 * 1.60;
  
  $$min{I}{CD1} = 3.20;
  $$max{I}{CD1} = 27.00;
  $$mean{I}{CD1} = 13.41;
  $$count{I}{CD1} = 1;
  $$variance{I}{CD1} = 1.91 * 1.91;
  
  $$min{I}{N} = 99.00;
  $$max{I}{N} = 135.00;
  $$mean{I}{N} = 121.60;
  $$count{I}{N} = 1;
  $$variance{I}{N} = 4.72 * 4.72;
  
  
  $$min{L}{H} = 5.38;
  $$max{L}{H} = 11.75;
  $$mean{L}{H} = 8.22;
  $$count{L}{H} = 1;
  $$variance{L}{H} = 0.65 * 0.65;
  
  $$min{L}{HA} = 2.31;
  $$max{L}{HA} = 6.15;
  $$mean{L}{HA} = 4.32;
  $$count{L}{HA} = 1;
  $$variance{L}{HA} = 0.47 * 0.47;
  
  $$min{L}{HB2} = -1.31;
  $$max{L}{HB2} = 3.02;
  $$mean{L}{HB2} = 1.63;
  $$count{L}{HB2} = 1;
  $$variance{L}{HB2} = 0.34 * 0.34;
  
  $$min{L}{HB3} = -1.21;
  $$max{L}{HB3} = 3.11;
  $$mean{L}{HB3} = 1.57;
  $$count{L}{HB3} = 1;
  $$variance{L}{HB3} = 0.36 * 0.36;
  
  $$min{L}{HG} = -1.06;
  $$max{L}{HG} = 3.90;
  $$mean{L}{HG} = 1.54;
  $$count{L}{HG} = 1;
  $$variance{L}{HG} = 0.33 * 0.33;
  
  $$min{L}{HD1} = -1.23;
  $$max{L}{HD1} = 2.36;
  $$mean{L}{HD1} = 0.77;
  $$count{L}{HD1} = 1;
  $$variance{L}{HD1} = 0.27 * 0.27;
  
  $$min{L}{HD2} = -1.45;
  $$max{L}{HD2} = 2.78;
  $$mean{L}{HD2} = 0.76;
  $$count{L}{HD2} = 1;
  $$variance{L}{HD2} = 0.28 * 0.28;
  
  $$min{L}{C} = 168.90;
  $$max{L}{C} = 189.78;
  $$mean{L}{C} = 176.97;
  $$count{L}{C} = 1;
  $$variance{L}{C} = 2.09 * 2.09;
  
  $$min{L}{CA} = 44.60;
  $$max{L}{CA} = 65.10;
  $$mean{L}{CA} = 55.65;
  $$count{L}{CA} = 1;
  $$variance{L}{CA} = 2.21 * 2.21;
  
  $$min{L}{CB} = 32.60;
  $$max{L}{CB} = 53.70;
  $$mean{L}{CB} = 42.37;
  $$count{L}{CB} = 1;
  $$variance{L}{CB} = 1.86 * 1.86;
  
  $$min{L}{CG} = 20.53;
  $$max{L}{CG} = 37.80;
  $$mean{L}{CG} = 26.77;
  $$count{L}{CG} = 1;
  $$variance{L}{CG} = 1.25 * 1.25;
  
  $$min{L}{CD1} = 11.70;
  $$max{L}{CD1} = 29.60;
  $$mean{L}{CD1} = 24.73;
  $$count{L}{CD1} = 1;
  $$variance{L}{CD1} = 1.71 * 1.71;
  
  $$min{L}{CD2} = 12.50;
  $$max{L}{CD2} = 28.60;
  $$mean{L}{CD2} = 24.10;
  $$count{L}{CD2} = 1;
  $$variance{L}{CD2} = 1.78 * 1.78;
  
  $$min{L}{N} = 109.76;
  $$max{L}{N} = 136.00;
  $$mean{L}{N} = 121.98;
  $$count{L}{N} = 1;
  $$variance{L}{N} = 4.07 * 4.07;
  
  
  $$min{K}{H} = 5.36;
  $$max{K}{H} = 11.53;
  $$mean{K}{H} = 8.22;
  $$count{K}{H} = 1;
  $$variance{K}{H} = 0.64 * 0.64;
  
  $$min{K}{HA} = 0.68;
  $$max{K}{HA} = 7.96;
  $$mean{K}{HA} = 4.28;
  $$count{K}{HA} = 1;
  $$variance{K}{HA} = 0.45 * 0.45;
  
  $$min{K}{HB2} = -0.15;
  $$max{K}{HB2} = 3.94;
  $$mean{K}{HB2} = 1.79;
  $$count{K}{HB2} = 1;
  $$variance{K}{HB2} = 0.25 * 0.25;
  
  $$min{K}{HB3} = -0.37;
  $$max{K}{HB3} = 3.94;
  $$mean{K}{HB3} = 1.78;
  $$count{K}{HB3} = 1;
  $$variance{K}{HB3} = 0.26 * 0.26;
  
  $$min{K}{HG2} = -0.69;
  $$max{K}{HG2} = 3.01;
  $$mean{K}{HG2} = 1.38;
  $$count{K}{HG2} = 1;
  $$variance{K}{HG2} = 0.27 * 0.27;
  
  $$min{K}{HG3} = -0.77;
  $$max{K}{HG3} = 2.99;
  $$mean{K}{HG3} = 1.37;
  $$count{K}{HG3} = 1;
  $$variance{K}{HG3} = 0.29 * 0.29;
  
  $$min{K}{HD2} = 0.32;
  $$max{K}{HD2} = 3.61;
  $$mean{K}{HD2} = 1.61;
  $$count{K}{HD2} = 1;
  $$variance{K}{HD2} = 0.25 * 0.25;
  
  $$min{K}{HD3} = 0.28;
  $$max{K}{HD3} = 3.61;
  $$mean{K}{HD3} = 1.61;
  $$count{K}{HD3} = 1;
  $$variance{K}{HD3} = 0.25 * 0.25;
  
  $$min{K}{HE2} = 1.25;
  $$max{K}{HE2} = 4.32;
  $$mean{K}{HE2} = 2.93;
  $$count{K}{HE2} = 1;
  $$variance{K}{HE2} = 0.20 * 0.20;
  
  $$min{K}{HE3} = 1.49;
  $$max{K}{HE3} = 4.32;
  $$mean{K}{HE3} = 2.93;
  $$count{K}{HE3} = 1;
  $$variance{K}{HE3} = 0.20 * 0.20;
  
  $$min{K}{HZ} = 2.85;
  $$max{K}{HZ} = 9.90;
  $$mean{K}{HZ} = 7.52;
  $$count{K}{HZ} = 1;
  $$variance{K}{HZ} = 0.36 * 0.36;
  
  $$min{K}{C} = 170.15;
  $$max{K}{C} = 181.50;
  $$mean{K}{C} = 176.46;
  $$count{K}{C} = 1;
  $$variance{K}{C} = 2.05 * 2.05;
  
  $$min{K}{CA} = 46.10;
  $$max{K}{CA} = 62.71;
  $$mean{K}{CA} = 56.84;
  $$count{K}{CA} = 1;
  $$variance{K}{CA} = 2.25 * 2.25;
  
  $$min{K}{CB} = 22.90;
  $$max{K}{CB} = 46.60;
  $$mean{K}{CB} = 32.83;
  $$count{K}{CB} = 1;
  $$variance{K}{CB} = 1.88 * 1.88;
  
  $$min{K}{CG} = 17.30;
  $$max{K}{CG} = 31.28;
  $$mean{K}{CG} = 24.91;
  $$count{K}{CG} = 1;
  $$variance{K}{CG} = 1.31 * 1.31;
  
  $$min{K}{CD} = 21.30;
  $$max{K}{CD} = 42.60;
  $$mean{K}{CD} = 28.78;
  $$count{K}{CD} = 1;
  $$variance{K}{CD} = 1.39 * 1.39;
  
  $$min{K}{CE} = 34.20;
  $$max{K}{CE} = 56.00;
  $$mean{K}{CE} = 41.78;
  $$count{K}{CE} = 1;
  $$variance{K}{CE} = 0.98 * 0.98;
  
  $$min{K}{N} = 105.45;
  $$max{K}{N} = 136.10;
  $$mean{K}{N} = 121.16;
  $$count{K}{N} = 1;
  $$variance{K}{N} = 4.11 * 4.11;
  
  $$min{K}{NZ} = 33.00;
  $$max{K}{NZ} = 131.04;
  $$mean{K}{NZ} = 71.86;
  $$count{K}{NZ} = 1;
  $$variance{K}{NZ} = 52.41 * 52.41;
  
  
  $$min{M}{H} = 5.80;
  $$max{M}{H} = 10.36;
  $$mean{M}{H} = 8.26;
  $$count{M}{H} = 1;
  $$variance{M}{H} = 0.60 * 0.60;
  
  $$min{M}{HA} = 2.80;
  $$max{M}{HA} = 6.22;
  $$mean{M}{HA} = 4.39;
  $$count{M}{HA} = 1;
  $$variance{M}{HA} = 0.46 * 0.46;
  
  $$min{M}{HB2} = -0.99;
  $$max{M}{HB2} = 4.07;
  $$mean{M}{HB2} = 2.03;
  $$count{M}{HB2} = 1;
  $$variance{M}{HB2} = 0.38 * 0.38;
  
  $$min{M}{HB3} = -0.97;
  $$max{M}{HB3} = 3.15;
  $$mean{M}{HB3} = 2.01;
  $$count{M}{HB3} = 1;
  $$variance{M}{HB3} = 0.36 * 0.36;
  
  $$min{M}{HG2} = -0.36;
  $$max{M}{HG2} = 3.80;
  $$mean{M}{HG2} = 2.44;
  $$count{M}{HG2} = 1;
  $$variance{M}{HG2} = 0.36 * 0.36;
  
  $$min{M}{HG3} = 0.18;
  $$max{M}{HG3} = 3.80;
  $$mean{M}{HG3} = 2.41;
  $$count{M}{HG3} = 1;
  $$variance{M}{HG3} = 0.40 * 0.40;
  
  $$min{M}{HE} = -0.19;
  $$max{M}{HE} = 3.30;
  $$mean{M}{HE} = 1.86;
  $$count{M}{HE} = 1;
  $$variance{M}{HE} = 0.47 * 0.47;
  
  $$min{M}{C} = 169.13;
  $$max{M}{C} = 181.20;
  $$mean{M}{C} = 176.30;
  $$count{M}{C} = 1;
  $$variance{M}{C} = 2.13 * 2.13;
  
  $$min{M}{CA} = 47.70;
  $$max{M}{CA} = 62.24;
  $$mean{M}{CA} = 56.16;
  $$count{M}{CA} = 1;
  $$variance{M}{CA} = 2.34 * 2.34;
  
  $$min{M}{CB} = 24.86;
  $$max{M}{CB} = 40.75;
  $$mean{M}{CB} = 32.90;
  $$count{M}{CB} = 1;
  $$variance{M}{CB} = 2.23 * 2.23;
  
  $$min{M}{CG} = 20.83;
  $$max{M}{CG} = 37.31;
  $$mean{M}{CG} = 32.07;
  $$count{M}{CG} = 1;
  $$variance{M}{CG} = 1.45 * 1.45;
  
  $$min{M}{CE} = 9.50;
  $$max{M}{CE} = 48.46;
  $$mean{M}{CE} = 17.21;
  $$count{M}{CE} = 1;
  $$variance{M}{CE} = 3.42 * 3.42;
  
  $$min{M}{N} = 107.82;
  $$max{M}{N} = 131.60;
  $$mean{M}{N} = 120.10;
  $$count{M}{N} = 1;
  $$variance{M}{N} = 3.88 * 3.88;
  
  
  $$min{F}{H} = 5.72;
  $$max{F}{H} = 11.46;
  $$mean{F}{H} = 8.42;
  $$count{F}{H} = 1;
  $$variance{F}{H} = 0.74 * 0.74;
  
  $$min{F}{HA} = 2.72;
  $$max{F}{HA} = 6.56;
  $$mean{F}{HA} = 4.62;
  $$count{F}{HA} = 1;
  $$variance{F}{HA} = 0.58 * 0.58;
  
  $$min{F}{HB2} = 0.43;
  $$max{F}{HB2} = 4.32;
  $$mean{F}{HB2} = 2.99;
  $$count{F}{HB2} = 1;
  $$variance{F}{HB2} = 0.37 * 0.37;
  
  $$min{F}{HB3} = 0.59;
  $$max{F}{HB3} = 3.99;
  $$mean{F}{HB3} = 2.97;
  $$count{F}{HB3} = 1;
  $$variance{F}{HB3} = 0.38 * 0.38;
  
  $$min{F}{HD1} = 2.02;
  $$max{F}{HD1} = 7.94;
  $$mean{F}{HD1} = 6.91;
  $$count{F}{HD1} = 1;
  $$variance{F}{HD1} = 0.82 * 0.82;
  
  $$min{F}{HD2} = 2.02;
  $$max{F}{HD2} = 8.08;
  $$mean{F}{HD2} = 6.89;
  $$count{F}{HD2} = 1;
  $$variance{F}{HD2} = 0.86 * 0.86;
  
  $$min{F}{HE1} = 2.95;
  $$max{F}{HE1} = 8.80;
  $$mean{F}{HE1} = 6.95;
  $$count{F}{HE1} = 1;
  $$variance{F}{HE1} = 0.82 * 0.82;
  
  $$min{F}{HE2} = 2.95;
  $$max{F}{HE2} = 8.80;
  $$mean{F}{HE2} = 6.94;
  $$count{F}{HE2} = 1;
  $$variance{F}{HE2} = 0.86 * 0.86;
  
  $$min{F}{HZ} = 3.04;
  $$max{F}{HZ} = 9.50;
  $$mean{F}{HZ} = 6.92;
  $$count{F}{HZ} = 1;
  $$variance{F}{HZ} = 0.80 * 0.80;
  
  $$min{F}{C} = 169.00;
  $$max{F}{C} = 181.00;
  $$mean{F}{C} = 175.49;
  $$count{F}{C} = 1;
  $$variance{F}{C} = 2.13 * 2.13;
  
  $$min{F}{CA} = 48.30;
  $$max{F}{CA} = 67.10;
  $$mean{F}{CA} = 58.25;
  $$count{F}{CA} = 1;
  $$variance{F}{CA} = 2.73 * 2.73;
  
  $$min{F}{CB} = 32.00;
  $$max{F}{CB} = 50.40;
  $$mean{F}{CB} = 39.95;
  $$count{F}{CB} = 1;
  $$variance{F}{CB} = 2.04 * 2.04;
  
  $$min{F}{CG} = 136.20;
  $$max{F}{CG} = 140.40;
  $$mean{F}{CG} = 138.35;
  $$count{F}{CG} = 1;
  $$variance{F}{CG} = 1.12 * 1.12;
  
  $$min{F}{CD1} = 118.50;
  $$max{F}{CD1} = 134.00;
  $$mean{F}{CD1} = 131.38;
  $$count{F}{CD1} = 1;
  $$variance{F}{CD1} = 1.38 * 1.38;
  
  $$min{F}{CD2} = 119.10;
  $$max{F}{CD2} = 137.20;
  $$mean{F}{CD2} = 131.33;
  $$count{F}{CD2} = 1;
  $$variance{F}{CD2} = 1.48 * 1.48;
  
  $$min{F}{CE1} = 117.50;
  $$max{F}{CE1} = 133.30;
  $$mean{F}{CE1} = 130.48;
  $$count{F}{CE1} = 1;
  $$variance{F}{CE1} = 1.29 * 1.29;
  
  $$min{F}{CE2} = 126.40;
  $$max{F}{CE2} = 133.30;
  $$mean{F}{CE2} = 130.60;
  $$count{F}{CE2} = 1;
  $$variance{F}{CE2} = 0.97 * 0.97;
  
  $$min{F}{CZ} = 118.70;
  $$max{F}{CZ} = 138.60;
  $$mean{F}{CZ} = 129.11;
  $$count{F}{CZ} = 1;
  $$variance{F}{CZ} = 1.68 * 1.68;
  
  $$min{F}{N} = 104.78;
  $$max{F}{N} = 134.60;
  $$mean{F}{N} = 120.69;
  $$count{F}{N} = 1;
  $$variance{F}{N} = 4.18 * 4.18;
  
  
  $$min{P}{HA} = 1.63;
  $$max{P}{HA} = 6.05;
  $$mean{P}{HA} = 4.41;
  $$count{P}{HA} = 1;
  $$variance{P}{HA} = 0.36 * 0.36;
  
  $$min{P}{HB2} = -0.78;
  $$max{P}{HB2} = 3.98;
  $$mean{P}{HB2} = 2.05;
  $$count{P}{HB2} = 1;
  $$variance{P}{HB2} = 0.39 * 0.39;
  
  $$min{P}{HB3} = -0.15;
  $$max{P}{HB3} = 3.98;
  $$mean{P}{HB3} = 2.05;
  $$count{P}{HB3} = 1;
  $$variance{P}{HB3} = 0.39 * 0.39;
  
  $$min{P}{HG2} = -0.93;
  $$max{P}{HG2} = 4.92;
  $$mean{P}{HG2} = 1.93;
  $$count{P}{HG2} = 1;
  $$variance{P}{HG2} = 0.36 * 0.36;
  
  $$min{P}{HG3} = -0.90;
  $$max{P}{HG3} = 4.92;
  $$mean{P}{HG3} = 1.92;
  $$count{P}{HG3} = 1;
  $$variance{P}{HG3} = 0.37 * 0.37;
  
  $$min{P}{HD2} = 1.01;
  $$max{P}{HD2} = 4.62;
  $$mean{P}{HD2} = 3.64;
  $$count{P}{HD2} = 1;
  $$variance{P}{HD2} = 0.36 * 0.36;
  
  $$min{P}{HD3} = 0.99;
  $$max{P}{HD3} = 5.16;
  $$mean{P}{HD3} = 3.63;
  $$count{P}{HD3} = 1;
  $$variance{P}{HD3} = 0.40 * 0.40;
  
  $$min{P}{C} = 170.95;
  $$max{P}{C} = 182.30;
  $$mean{P}{C} = 176.70;
  $$count{P}{C} = 1;
  $$variance{P}{C} = 1.69 * 1.69;
  
  $$min{P}{CA} = 50.12;
  $$max{P}{CA} = 68.10;
  $$mean{P}{CA} = 63.30;
  $$count{P}{CA} = 1;
  $$variance{P}{CA} = 1.64 * 1.64;
  
  $$min{P}{CB} = 26.32;
  $$max{P}{CB} = 56.76;
  $$mean{P}{CB} = 31.81;
  $$count{P}{CB} = 1;
  $$variance{P}{CB} = 1.54 * 1.54;
  
  $$min{P}{CG} = 19.31;
  $$max{P}{CG} = 33.39;
  $$mean{P}{CG} = 27.14;
  $$count{P}{CG} = 1;
  $$variance{P}{CG} = 1.18 * 1.18;
  
  $$min{P}{CD} = 40.44;
  $$max{P}{CD} = 56.00;
  $$mean{P}{CD} = 50.28;
  $$count{P}{CD} = 1;
  $$variance{P}{CD} = 1.04 * 1.04;
  
  $$min{P}{N} = 106.00;
  $$max{P}{N} = 144.29;
  $$mean{P}{N} = 127.40;
  $$count{P}{N} = 1;
  $$variance{P}{N} = 10.05 * 10.05;
  
  
  $$min{S}{H} = 2.96;
  $$max{S}{H} = 11.68;
  $$mean{S}{H} = 8.29;
  $$count{S}{H} = 1;
  $$variance{S}{H} = 0.62 * 0.62;
  
  $$min{S}{HA} = 1.43;
  $$max{S}{HA} = 6.37;
  $$mean{S}{HA} = 4.51;
  $$count{S}{HA} = 1;
  $$variance{S}{HA} = 0.43 * 0.43;
  
  $$min{S}{HB2} = 1.48;
  $$max{S}{HB2} = 4.99;
  $$mean{S}{HB2} = 3.88;
  $$count{S}{HB2} = 1;
  $$variance{S}{HB2} = 0.29 * 0.29;
  
  $$min{S}{HB3} = 1.51;
  $$max{S}{HB3} = 4.96;
  $$mean{S}{HB3} = 3.87;
  $$count{S}{HB3} = 1;
  $$variance{S}{HB3} = 0.31 * 0.31;
  
  $$min{S}{HG} = 1.10;
  $$max{S}{HG} = 8.97;
  $$mean{S}{HG} = 5.33;
  $$count{S}{HG} = 1;
  $$variance{S}{HG} = 1.16 * 1.16;
  
  $$min{S}{C} = 166.90;
  $$max{S}{C} = 181.40;
  $$mean{S}{C} = 174.53;
  $$count{S}{C} = 1;
  $$variance{S}{C} = 1.73 * 1.73;
  
  $$min{S}{CA} = 48.90;
  $$max{S}{CA} = 66.91;
  $$mean{S}{CA} = 58.57;
  $$count{S}{CA} = 1;
  $$variance{S}{CA} = 2.12 * 2.12;
  
  $$min{S}{CB} = 55.50;
  $$max{S}{CB} = 70.80;
  $$mean{S}{CB} = 63.80;
  $$count{S}{CB} = 1;
  $$variance{S}{CB} = 1.57 * 1.57;
  
  $$min{S}{N} = 102.60;
  $$max{S}{N} = 133.10;
  $$mean{S}{N} = 116.30;
  $$count{S}{N} = 1;
  $$variance{S}{N} = 3.95 * 3.95;
  
  
  $$min{T}{H} = 5.93;
  $$max{T}{H} = 11.01;
  $$mean{T}{H} = 8.27;
  $$count{T}{H} = 1;
  $$variance{T}{H} = 0.62 * 0.62;
  
  $$min{T}{HA} = 0.87;
  $$max{T}{HA} = 6.35;
  $$mean{T}{HA} = 4.48;
  $$count{T}{HA} = 1;
  $$variance{T}{HA} = 0.50 * 0.50;
  
  $$min{T}{HB} = 0.92;
  $$max{T}{HB} = 5.90;
  $$mean{T}{HB} = 4.17;
  $$count{T}{HB} = 1;
  $$variance{T}{HB} = 0.37 * 0.37;
  
  $$min{T}{HG1} = 0.32;
  $$max{T}{HG1} = 8.21;
  $$mean{T}{HG1} = 4.40;
  $$count{T}{HG1} = 1;
  $$variance{T}{HG1} = 1.92 * 1.92;
  
  $$min{T}{HG2} = -0.83;
  $$max{T}{HG2} = 4.35;
  $$mean{T}{HG2} = 1.16;
  $$count{T}{HG2} = 1;
  $$variance{T}{HG2} = 0.28 * 0.28;
  
  $$min{T}{C} = 165.50;
  $$max{T}{C} = 181.39;
  $$mean{T}{C} = 174.60;
  $$count{T}{C} = 1;
  $$variance{T}{C} = 1.80 * 1.80;
  
  $$min{T}{CA} = 52.00;
  $$max{T}{CA} = 69.18;
  $$mean{T}{CA} = 62.15;
  $$count{T}{CA} = 1;
  $$variance{T}{CA} = 2.72 * 2.72;
  
  $$min{T}{CB} = 58.60;
  $$max{T}{CB} = 78.30;
  $$mean{T}{CB} = 69.64;
  $$count{T}{CB} = 1;
  $$variance{T}{CB} = 1.70 * 1.70;
  
  $$min{T}{CG2} = 13.20;
  $$max{T}{CG2} = 38.90;
  $$mean{T}{CG2} = 21.44;
  $$count{T}{CG2} = 1;
  $$variance{T}{CG2} = 1.39 * 1.39;
  
  $$min{T}{N} = 97.70;
  $$max{T}{N} = 132.80;
  $$mean{T}{N} = 115.70;
  $$count{T}{N} = 1;
  $$variance{T}{N} = 5.05 * 5.05;
  
  
  $$min{W}{H} = 5.73;
  $$max{W}{H} = 10.76;
  $$mean{W}{H} = 8.35;
  $$count{W}{H} = 1;
  $$variance{W}{H} = 0.84 * 0.84;
  
  $$min{W}{HA} = 2.28;
  $$max{W}{HA} = 6.75;
  $$mean{W}{HA} = 4.74;
  $$count{W}{HA} = 1;
  $$variance{W}{HA} = 0.55 * 0.55;
  
  $$min{W}{HB2} = 0.42;
  $$max{W}{HB2} = 4.54;
  $$mean{W}{HB2} = 3.22;
  $$count{W}{HB2} = 1;
  $$variance{W}{HB2} = 0.36 * 0.36;
  
  $$min{W}{HB3} = 1.02;
  $$max{W}{HB3} = 4.49;
  $$mean{W}{HB3} = 3.18;
  $$count{W}{HB3} = 1;
  $$variance{W}{HB3} = 0.36 * 0.36;
  
  $$min{W}{HD1} = 5.81;
  $$max{W}{HD1} = 8.93;
  $$mean{W}{HD1} = 7.16;
  $$count{W}{HD1} = 1;
  $$variance{W}{HD1} = 0.34 * 0.34;
  
  $$min{W}{HE1} = 6.79;
  $$max{W}{HE1} = 11.90;
  $$mean{W}{HE1} = 10.13;
  $$count{W}{HE1} = 1;
  $$variance{W}{HE1} = 0.53 * 0.53;
  
  $$min{W}{HE3} = 1.85;
  $$max{W}{HE3} = 8.98;
  $$mean{W}{HE3} = 7.17;
  $$count{W}{HE3} = 1;
  $$variance{W}{HE3} = 1.03 * 1.03;
  
  $$min{W}{HZ2} = 2.63;
  $$max{W}{HZ2} = 8.60;
  $$mean{W}{HZ2} = 7.14;
  $$count{W}{HZ2} = 1;
  $$variance{W}{HZ2} = 0.89 * 0.89;
  
  $$min{W}{HZ3} = 0.76;
  $$max{W}{HZ3} = 8.20;
  $$mean{W}{HZ3} = 6.68;
  $$count{W}{HZ3} = 1;
  $$variance{W}{HZ3} = 1.02 * 1.02;
  
  $$min{W}{HH2} = 2.84;
  $$max{W}{HH2} = 10.17;
  $$mean{W}{HH2} = 6.82;
  $$count{W}{HH2} = 1;
  $$variance{W}{HH2} = 0.94 * 0.94;
  
  $$min{W}{C} = 170.70;
  $$max{W}{C} = 180.82;
  $$mean{W}{C} = 176.10;
  $$count{W}{C} = 1;
  $$variance{W}{C} = 1.89 * 1.89;
  
  $$min{W}{CA} = 47.70;
  $$max{W}{CA} = 65.12;
  $$mean{W}{CA} = 57.71;
  $$count{W}{CA} = 1;
  $$variance{W}{CA} = 2.65 * 2.65;
  
  $$min{W}{CB} = 24.10;
  $$max{W}{CB} = 43.02;
  $$mean{W}{CB} = 30.16;
  $$count{W}{CB} = 1;
  $$variance{W}{CB} = 2.19 * 2.19;
  
  $$min{W}{CG} = 107.50;
  $$max{W}{CG} = 114.60;
  $$mean{W}{CG} = 110.37;
  $$count{W}{CG} = 1;
  $$variance{W}{CG} = 1.55 * 1.55;
  
  $$min{W}{CD1} = 119.50;
  $$max{W}{CD1} = 129.80;
  $$mean{W}{CD1} = 126.16;
  $$count{W}{CD1} = 1;
  $$variance{W}{CD1} = 1.76 * 1.76;
  
  $$min{W}{CD2} = 120.20;
  $$max{W}{CD2} = 130.10;
  $$mean{W}{CD2} = 127.40;
  $$count{W}{CD2} = 1;
  $$variance{W}{CD2} = 1.33 * 1.33;
  
  $$min{W}{CE2} = 118.37;
  $$max{W}{CE2} = 139.20;
  $$mean{W}{CE2} = 137.38;
  $$count{W}{CE2} = 1;
  $$variance{W}{CE2} = 2.86 * 2.86;
  
  $$min{W}{CE3} = 116.50;
  $$max{W}{CE3} = 127.30;
  $$mean{W}{CE3} = 120.38;
  $$count{W}{CE3} = 1;
  $$variance{W}{CE3} = 1.50 * 1.50;
  
  $$min{W}{CZ2} = 111.18;
  $$max{W}{CZ2} = 118.90;
  $$mean{W}{CZ2} = 114.19;
  $$count{W}{CZ2} = 1;
  $$variance{W}{CZ2} = 1.09 * 1.09;
  
  $$min{W}{CZ3} = 116.46;
  $$max{W}{CZ3} = 129.70;
  $$mean{W}{CZ3} = 121.57;
  $$count{W}{CZ3} = 1;
  $$variance{W}{CZ3} = 1.76 * 1.76;
  
  $$min{W}{CH2} = 119.60;
  $$max{W}{CH2} = 128.73;
  $$mean{W}{CH2} = 123.75;
  $$count{W}{CH2} = 1;
  $$variance{W}{CH2} = 1.34 * 1.34;
  
  $$min{W}{N} = 101.75;
  $$max{W}{N} = 134.59;
  $$mean{W}{N} = 121.87;
  $$count{W}{N} = 1;
  $$variance{W}{N} = 4.58 * 4.58;
  
  $$min{W}{NE1} = 106.75;
  $$max{W}{NE1} = 136.30;
  $$mean{W}{NE1} = 129.48;
  $$count{W}{NE1} = 1;
  $$variance{W}{NE1} = 2.56 * 2.56;
  
  
  $$min{Y}{H} = 5.64;
  $$max{Y}{H} = 11.92;
  $$mean{Y}{H} = 8.37;
  $$count{Y}{H} = 1;
  $$variance{Y}{H} = 0.75 * 0.75;
  
  $$min{Y}{HA} = 1.20;
  $$max{Y}{HA} = 6.65;
  $$mean{Y}{HA} = 4.63;
  $$count{Y}{HA} = 1;
  $$variance{Y}{HA} = 0.56 * 0.56;
  
  $$min{Y}{HB2} = 0.31;
  $$max{Y}{HB2} = 4.70;
  $$mean{Y}{HB2} = 2.91;
  $$count{Y}{HB2} = 1;
  $$variance{Y}{HB2} = 0.37 * 0.37;
  
  $$min{Y}{HB3} = 0.34;
  $$max{Y}{HB3} = 4.70;
  $$mean{Y}{HB3} = 2.91;
  $$count{Y}{HB3} = 1;
  $$variance{Y}{HB3} = 0.37 * 0.37;
  
  $$min{Y}{HD1} = 2.77;
  $$max{Y}{HD1} = 8.00;
  $$mean{Y}{HD1} = 6.87;
  $$count{Y}{HD1} = 1;
  $$variance{Y}{HD1} = 0.65 * 0.65;
  
  $$min{Y}{HD2} = 2.77;
  $$max{Y}{HD2} = 8.50;
  $$mean{Y}{HD2} = 6.86;
  $$count{Y}{HD2} = 1;
  $$variance{Y}{HD2} = 0.68 * 0.68;
  
  $$min{Y}{HE1} = 2.61;
  $$max{Y}{HE1} = 7.86;
  $$mean{Y}{HE1} = 6.64;
  $$count{Y}{HE1} = 1;
  $$variance{Y}{HE1} = 0.58 * 0.58;
  
  $$min{Y}{HE2} = 2.61;
  $$max{Y}{HE2} = 8.50;
  $$mean{Y}{HE2} = 6.63;
  $$count{Y}{HE2} = 1;
  $$variance{Y}{HE2} = 0.61 * 0.61;
  
  $$min{Y}{HH} = 5.96;
  $$max{Y}{HH} = 13.03;
  $$mean{Y}{HH} = 9.25;
  $$count{Y}{HH} = 1;
  $$variance{Y}{HH} = 1.34 * 1.34;
  
  $$min{Y}{C} = 169.20;
  $$max{Y}{C} = 180.34;
  $$mean{Y}{C} = 175.39;
  $$count{Y}{C} = 1;
  $$variance{Y}{C} = 1.89 * 1.89;
  
  $$min{Y}{CA} = 45.20;
  $$max{Y}{CA} = 65.80;
  $$mean{Y}{CA} = 58.02;
  $$count{Y}{CA} = 1;
  $$variance{Y}{CA} = 2.64 * 2.64;
  
  $$min{Y}{CB} = 29.20;
  $$max{Y}{CB} = 46.06;
  $$mean{Y}{CB} = 39.16;
  $$count{Y}{CB} = 1;
  $$variance{Y}{CB} = 2.23 * 2.23;
  
  $$min{Y}{CG} = 125.70;
  $$max{Y}{CG} = 131.10;
  $$mean{Y}{CG} = 129.29;
  $$count{Y}{CG} = 1;
  $$variance{Y}{CG} = 1.21 * 1.21;
  
  $$min{Y}{CD1} = 122.10;
  $$max{Y}{CD1} = 136.70;
  $$mean{Y}{CD1} = 132.54;
  $$count{Y}{CD1} = 1;
  $$variance{Y}{CD1} = 1.35 * 1.35;
  
  $$min{Y}{CD2} = 118.15;
  $$max{Y}{CD2} = 136.70;
  $$mean{Y}{CD2} = 132.26;
  $$count{Y}{CD2} = 1;
  $$variance{Y}{CD2} = 1.99 * 1.99;
  
  $$min{Y}{CE1} = 110.70;
  $$max{Y}{CE1} = 133.31;
  $$mean{Y}{CE1} = 117.81;
  $$count{Y}{CE1} = 1;
  $$variance{Y}{CE1} = 2.09 * 2.09;
  
  $$min{Y}{CE2} = 115.00;
  $$max{Y}{CE2} = 133.31;
  $$mean{Y}{CE2} = 117.91;
  $$count{Y}{CE2} = 1;
  $$variance{Y}{CE2} = 2.60 * 2.60;
  
  $$min{Y}{CZ} = 153.54;
  $$max{Y}{CZ} = 162.70;
  $$mean{Y}{CZ} = 156.37;
  $$count{Y}{CZ} = 1;
  $$variance{Y}{CZ} = 2.50 * 2.50;
  
  $$min{Y}{N} = 104.60;
  $$max{Y}{N} = 134.53;
  $$mean{Y}{N} = 120.79;
  $$count{Y}{N} = 1;
  $$variance{Y}{N} = 4.69 * 4.69;
  
  
  $$min{V}{H} = 3.98;
  $$max{V}{H} = 11.03;
  $$mean{V}{H} = 8.29;
  $$count{V}{H} = 1;
  $$variance{V}{H} = 0.71 * 0.71;
  
  $$min{V}{HA} = 1.73;
  $$max{V}{HA} = 6.13;
  $$mean{V}{HA} = 4.16;
  $$count{V}{HA} = 1;
  $$variance{V}{HA} = 0.57 * 0.57;
  
  $$min{V}{HB} = -0.56;
  $$max{V}{HB} = 3.42;
  $$mean{V}{HB} = 1.99;
  $$count{V}{HB} = 1;
  $$variance{V}{HB} = 0.33 * 0.33;
  
  $$min{V}{HG1} = -1.09;
  $$max{V}{HG1} = 2.31;
  $$mean{V}{HG1} = 0.84;
  $$count{V}{HG1} = 1;
  $$variance{V}{HG1} = 0.27 * 0.27;
  
  $$min{V}{HG2} = -2.32;
  $$max{V}{HG2} = 3.32;
  $$mean{V}{HG2} = 0.83;
  $$count{V}{HG2} = 1;
  $$variance{V}{HG2} = 0.29 * 0.29;
  
  $$min{V}{C} = 168.50;
  $$max{V}{C} = 181.44;
  $$mean{V}{C} = 175.69;
  $$count{V}{C} = 1;
  $$variance{V}{C} = 2.03 * 2.03;
  
  $$min{V}{CA} = 51.10;
  $$max{V}{CA} = 69.74;
  $$mean{V}{CA} = 62.48;
  $$count{V}{CA} = 1;
  $$variance{V}{CA} = 3.04 * 3.04;
  
  $$min{V}{CB} = 22.04;
  $$max{V}{CB} = 40.75;
  $$mean{V}{CB} = 32.66;
  $$count{V}{CB} = 1;
  $$variance{V}{CB} = 1.91 * 1.91;
  
  $$min{V}{CG1} = 11.60;
  $$max{V}{CG1} = 26.90;
  $$mean{V}{CG1} = 21.38;
  $$count{V}{CG1} = 1;
  $$variance{V}{CG1} = 1.53 * 1.53;
  
  $$min{V}{CG2} = 11.30;
  $$max{V}{CG2} = 28.74;
  $$mean{V}{CG2} = 21.31;
  $$count{V}{CG2} = 1;
  $$variance{V}{CG2} = 1.76 * 1.76;
  
  $$min{V}{N} = 96.29;
  $$max{V}{N} = 136.80;
  $$mean{V}{N} = 121.02;
  $$count{V}{N} = 1;
  $$variance{V}{N} = 4.96 * 4.96;

  # calculate deuteration isotope corrections if deuteration is present
  if ($deuteration > 0)
    {
    my $deuteration_corrections = {};


    # corrections for CA's calculated from Sandy Farmer's macro values.
    # corrections for sidechain carbons calculated from small molecule studies.
    # corrections for nitrogens come from a rough estimate of 0.16 for 2-bond effects and 0.06 for 3-bond effects
    # for A
    $$deuteration_corrections{A}{CA} =0.752;
    $$deuteration_corrections{A}{CB} =0.932;
    $$deuteration_corrections{A}{N} =0.34;

    # for C
    $$deuteration_corrections{C}{CA} =0.632;
    $$deuteration_corrections{C}{CB} =0.837;
    $$deuteration_corrections{C}{N} =0.28;

    # for D
    $$deuteration_corrections{D}{CA} =0.632;
    $$deuteration_corrections{D}{CB} =0.69;
    $$deuteration_corrections{D}{N} =0.28;

    # for E
    $$deuteration_corrections{E}{CA} =0.716;
    $$deuteration_corrections{E}{CB} =0.937;
    $$deuteration_corrections{E}{CG} =0.83;
    $$deuteration_corrections{E}{N} =0.28;

    # for F
    $$deuteration_corrections{F}{CA} =0.632;
    $$deuteration_corrections{F}{CB} =0.919;
    $$deuteration_corrections{F}{CG} =0.274;
    $$deuteration_corrections{F}{CD1} =0.429;
    $$deuteration_corrections{F}{CD2} =0.429;
    $$deuteration_corrections{F}{CE1} =0.500;
    $$deuteration_corrections{F}{CE2} =0.500;
    $$deuteration_corrections{F}{CZ} =0.496;
    $$deuteration_corrections{F}{N} =0.28;

    # for G
    $$deuteration_corrections{G}{CA} =0.784;
    $$deuteration_corrections{G}{N} =0.32;

    # for H
    $$deuteration_corrections{H}{CA} =0.632;
    $$deuteration_corrections{H}{CB} =0.832;
    $$deuteration_corrections{H}{CG} =0.365;
    $$deuteration_corrections{H}{CD2} =0.545;
    $$deuteration_corrections{H}{CE1} =0.475;
    $$deuteration_corrections{H}{N} =0.28;
    $$deuteration_corrections{H}{ND1} =0.34;
    $$deuteration_corrections{H}{NE2} =0.32;

    # for I
    $$deuteration_corrections{I}{CA} =0.722;
    $$deuteration_corrections{I}{CB} =1.092;
    $$deuteration_corrections{I}{CG1} =1.130;
    $$deuteration_corrections{I}{CG2} =1.020;
    $$deuteration_corrections{I}{CD1} =1.090;
    $$deuteration_corrections{I}{N} =0.22;

    # for K
    $$deuteration_corrections{K}{CA} =0.716;
    $$deuteration_corrections{K}{CB} =1.067;
    $$deuteration_corrections{K}{CG} =1.225;
    $$deuteration_corrections{K}{CD} =1.190;
    $$deuteration_corrections{K}{CE} =0.990;
    $$deuteration_corrections{K}{N} =0.28;
    $$deuteration_corrections{K}{NZ} =0.44;

    # for L
    $$deuteration_corrections{L}{CA} =0.674;
    $$deuteration_corrections{L}{CB} =1.067;
    $$deuteration_corrections{L}{CG} =1.215;
    $$deuteration_corrections{L}{CD1} =1.090;
    $$deuteration_corrections{L}{CD2} =1.090;
    $$deuteration_corrections{L}{N} =0.28;

    # for M
    $$deuteration_corrections{M}{CA} =0.716;
    $$deuteration_corrections{M}{CB} =0.917;
    $$deuteration_corrections{M}{CG} =0.995;
    $$deuteration_corrections{M}{CE} =0.855;
    $$deuteration_corrections{M}{N} =0.28;

    # for N
    $$deuteration_corrections{N}{CA} =0.632;
    $$deuteration_corrections{N}{CB} =0.757;
    $$deuteration_corrections{N}{N} =0.28;

    # for P
    $$deuteration_corrections{P}{CA} =0.716;
    $$deuteration_corrections{P}{CB} =1.027;
    $$deuteration_corrections{P}{CG} =1.158;
    $$deuteration_corrections{P}{CD} =0.952;
    $$deuteration_corrections{P}{N} =0.72;

    # for Q
    $$deuteration_corrections{Q}{CA} =0.716;
    $$deuteration_corrections{Q}{CB} =0.951;
    $$deuteration_corrections{Q}{CG} =0.915;
    $$deuteration_corrections{Q}{N} =0.28;

    # for R
    $$deuteration_corrections{R}{CA} =0.716;
    $$deuteration_corrections{R}{CB} =1.067;
    $$deuteration_corrections{R}{CG} =1.155;
    $$deuteration_corrections{R}{CD} =0.990;
    $$deuteration_corrections{R}{CZ} =0.070;
    $$deuteration_corrections{R}{N} =0.28;
    $$deuteration_corrections{R}{NE} =0.44;

    # for S
    $$deuteration_corrections{S}{CA} =0.632;
    $$deuteration_corrections{S}{CB} =0.837;
    $$deuteration_corrections{S}{N} =0.28;

    # for T
    $$deuteration_corrections{T}{CA} =0.638;
    $$deuteration_corrections{T}{CB} =0.867;
    $$deuteration_corrections{T}{CG} =0.950;
    $$deuteration_corrections{T}{N} =0.22;

    # for V
    $$deuteration_corrections{V}{CA} =0.764;
    $$deuteration_corrections{V}{CB} =1.057;
    $$deuteration_corrections{V}{CG1} =0.950;
    $$deuteration_corrections{V}{CG2} =0.950;
    $$deuteration_corrections{V}{N} =0.22;

    # for W
    $$deuteration_corrections{W}{CA} =0.632;
    $$deuteration_corrections{W}{CB} =0.832;
    $$deuteration_corrections{W}{CG} =0.365;
    $$deuteration_corrections{W}{CD1} =0.350;
    $$deuteration_corrections{W}{CD2} =0.213;
    $$deuteration_corrections{W}{CE2} =0.167;
    $$deuteration_corrections{W}{CE3} =0.429;
    $$deuteration_corrections{W}{CZ2} =0.429;
    $$deuteration_corrections{W}{CZ3} =0.511;
    $$deuteration_corrections{W}{CH2} =0.511;
    $$deuteration_corrections{W}{N} =0.28;
    $$deuteration_corrections{W}{NE1} =0.22;

    # for Y
    $$deuteration_corrections{Y}{CA} =0.632;
    $$deuteration_corrections{Y}{CB} =0.919;
    $$deuteration_corrections{Y}{CG} =0.299;
    $$deuteration_corrections{Y}{CD1} =0.418;
    $$deuteration_corrections{Y}{CD2} =0.418;
    $$deuteration_corrections{Y}{CE1} =0.390;
    $$deuteration_corrections{Y}{CE2} =0.390;
    $$deuteration_corrections{Y}{CZ} =0.220;
    $$deuteration_corrections{Y}{N} =0.28;


    # make the corrections
    foreach my $aa (keys %{$deuteration_corrections})
      {
      foreach my $atom (keys %{$$deuteration_corrections{$aa}})
	{
	$$min{$aa}{$atom} -= ($$deuteration_corrections{$aa}{$atom} * $deuteration);
	$$max{$aa}{$atom} -= ($$deuteration_corrections{$aa}{$atom} * $deuteration);
	$$mean{$aa}{$atom} -= ($$deuteration_corrections{$aa}{$atom} * $deuteration);
	}
      }
    }


  my $std = {};
  foreach my $aa (keys %$variance)
    {
    foreach my $shift (keys %{$$variance{$aa}})
      { $$std{$aa}{$shift} = sqrt($$variance{$aa}{$shift});  }
    }

  return $count, $mean, $variance, $std, $min, $max;  
  }


sub amino_acid_type_lists
  {
  my $use_sidechains = 1;
  if (@_)
    { $use_sidechains = shift @_; }
  my $use_aromatics = 0; 
  if (@_)
    { $use_aromatics = shift @_; }  
  my $use_carbonyls = 0;
  if (@_)
    { $use_carbonyls = shift @_; }  

  my $restricted_type_lists = {};
  if (! $use_sidechains)
    {
    $$restricted_type_lists{P} = ['CA', 'CB'];
    $$restricted_type_lists{Q} = ['CA', 'CB'];
    $$restricted_type_lists{A} = ['CA', 'CB'];
    $$restricted_type_lists{R} = ['CA', 'CB'];
    $$restricted_type_lists{S} = ['CA', 'CB'];
    $$restricted_type_lists{C} = ['CA', 'CB'];
    $$restricted_type_lists{T} = ['CA', 'CB'];
    $$restricted_type_lists{D} = ['CA', 'CB'];
    $$restricted_type_lists{E} = ['CA', 'CB'];
    $$restricted_type_lists{V} = ['CA', 'CB'];
    $$restricted_type_lists{F} = ['CA', 'CB'];
    $$restricted_type_lists{W} = ['CA', 'CB'];
    $$restricted_type_lists{G} = ['CA'];
    $$restricted_type_lists{H} = ['CA', 'CB'];
    $$restricted_type_lists{Y} = ['CA', 'CB'];
    $$restricted_type_lists{I} = ['CA', 'CB'];
    $$restricted_type_lists{K} = ['CA', 'CB'];
    $$restricted_type_lists{L} = ['CA', 'CB'];
    $$restricted_type_lists{M} = ['CA', 'CB'];
    $$restricted_type_lists{N} = ['CA', 'CB'];
    }
  else
    {
    $$restricted_type_lists{P} = ['CA', 'CB', 'CD', 'CG'];
    $$restricted_type_lists{Q} = ['CA', 'CB', 'CD', 'CG'];
    $$restricted_type_lists{A} = ['CA', 'CB'];
    $$restricted_type_lists{R} = ['CA', 'CB', 'CD', 'CG'];
    $$restricted_type_lists{S} = ['CA', 'CB'];
    $$restricted_type_lists{C} = ['CA', 'CB'];
    $$restricted_type_lists{T} = ['CA', 'CB', 'CG2'];
    $$restricted_type_lists{D} = ['CA', 'CB', 'CG'];
    $$restricted_type_lists{E} = ['CA', 'CB', 'CD', 'CG'];
    $$restricted_type_lists{V} = ['CA', 'CB', 'CG1', 'CG2'];
    $$restricted_type_lists{F} = ['CA', 'CB', 'CD1', 'CD2', 'CE1', 'CE2', 'CG', 'CZ'];
    $$restricted_type_lists{W} = ['CA', 'CB', 'CD1', 'CD2', 'CE2', 'CE3', 'CG', 'CH2', 'CZ2', 'CZ3'];
    $$restricted_type_lists{G} = ['CA'];
    $$restricted_type_lists{H} = ['CA', 'CB', 'CD2', 'CE1','CG'];
    $$restricted_type_lists{Y} = ['CA', 'CB', 'CD1', 'CD2', 'CE1', 'CE2', 'CG', 'CZ'];
    $$restricted_type_lists{I} = ['CA', 'CB', 'CD1', 'CG1', 'CG2'];
    $$restricted_type_lists{K} = ['CA', 'CB', 'CD', 'CE', 'CG'];
    $$restricted_type_lists{L} = ['CA', 'CB', 'CD1', 'CD2', 'CG'];
    $$restricted_type_lists{M} = ['CA', 'CB', 'CE', 'CG'];
    $$restricted_type_lists{N} = ['CA', 'CB', 'CG'];
    }


  if (! $use_aromatics)
    {
    foreach my $aa (qw(F Y W))
      { @{$$restricted_type_lists{$aa}} = grep { $_ eq "CA" || $_ eq "CB"; } @{$$restricted_type_lists{$aa}}; }
    }

  if ($use_carbonyls)
    {
    foreach my $aa (keys %$restricted_type_lists)
      { push @{$$restricted_type_lists{$aa}}, "C"; }
    }

  return $restricted_type_lists;
  }
